SystemOrganization addCategory: #'tODE-Views'!

!Object methodsFor: '*tode-views' stamp: 'dkh 5/24/2011 01:29'!
renderClassTabOn: html frame: frame tOdeMain: main
	(frame properties
		at: #classBrowser
		ifAbsent: [ 
			frame properties
				at: #classBrowser
				put:
					((TOClassBrowser new)
						object: self;
						frame: frame;
						yourself) ]) renderContentOn: html main: main! !

!Object methodsFor: '*tode-views' stamp: 'dkh 5/22/2011 16:43'!
renderHelpTabOn: html frame: frame tOdeMain: main
	self isBehavior
		ifTrue: [ 
			(html heading)
				level: 3;
				with: 'I am the Class ', self name.
			html preformatted: self comment ]
		ifFalse: [ 
			(html heading)
				level: 3;
				with: 'I am an instance of ', self class name.
			html preformatted: self class comment ]	! !

!Object methodsFor: '*tode-views' stamp: 'dkh 5/24/2011 01:30'!
renderInspectorTabOn: html frame: frame tOdeMain: main
	(frame properties
		at: #inspector
		ifAbsent: [ 
			frame properties
				at: #inspector
				put:
					((TOInspector new)
						object: self;
						frame: frame;
						yourself) ]) renderContentOn: html main: main! !

!Object methodsFor: '*tode-views' stamp: 'dkh 5/24/2011 01:35'!
renderMethodTabOn: html frame: frame tOdeMain: main
	(frame properties
		at: #methodBrowser
		ifAbsent: [ 
			frame properties
				at: #methodBrowser
				put:
					((TOMethodBrowser new)
						object: self;
						frame: frame;
						yourself) ]) renderContentOn: html main: main! !

!Object methodsFor: '*tode-views' stamp: 'dkh 5/22/2011 12:25'!
tODEBasicInspectorFields
	<tODEBasicInspectorFields>
	| members |
	members := WriteStream on: Array new.
	self class allInstVarNames 
		keysAndValuesDo: [ :index :each | members nextPut: each -> (self instVarAt: index) ].
	self class isVariable
		ifTrue: [ 1 to: self basicSize do: [ :index | members nextPut: index -> (self basicAt: index) ] ].
	^ members contents! !

!Object methodsFor: '*tode-views' stamp: 'dkh 5/23/2011 23:10'!
tODEClassTabSpec
	<tODECenterTabSpec>

	^ (TOTabSpec new)
		id: #classBrowser;
		receiver: self;
		label: 'class';
		order: 25;
		group: 'development';
		renderSelector: #renderClassTabOn:frame:tOdeMain:! !

!Object methodsFor: '*tode-views' stamp: 'dkh 5/23/2011 23:10'!
tODEHelpTabSpec
	<tODECenterTabSpec>

	^ (TOTabSpec new)
		id: #help;
		receiver: self;
		label: 'help';
		order: 25;
		group: 'basic';
		renderSelector: #renderHelpTabOn:frame:tOdeMain:! !

!Object methodsFor: '*tode-views' stamp: 'dkh 5/23/2011 23:10'!
tODEInspectorTabSpec
	<tODECenterTabSpec>

	^ (TOTabSpec new)
		id: #inspect;
		receiver: self;
		label: 'inspect';
		order: 50;
		group: 'basic';
		renderSelector: #renderInspectorTabOn:frame:tOdeMain:! !

!Object methodsFor: '*tode-views' stamp: 'dkh 5/23/2011 23:10'!
tODEMethodTabSpec
	<tODECenterTabSpec>

	^ (TOTabSpec new)
		id: #methodBrowser;
		receiver: self;
		label: 'method';
		order: 50;
		group: 'development';
		renderSelector: #renderMethodTabOn:frame:tOdeMain:! !

TOView subclass: #TOClassBasedBrowser
	instanceVariableNames: 'selectedSuperclass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-Views'!

!TOClassBasedBrowser methodsFor: 'rendering' stamp: 'dkh 5/24/2011 01:27'!
renderSuperclassHeading: aClass whenClicked: aBlock on: html main: main
	html text: 'Superclasses: '.
	aClass allSuperclasses reversed
		do: [ :supClass | 
			supClass == self selectedSuperclass
				ifTrue: [ html strong: supClass name ]
				ifFalse: [ 
					self
						renderLink: [ :s | 
							self selectedSuperclass: supClass.
							aBlock value.
							main updateCenterSideHistory: s ]
						with: [ html strong: supClass name ]
						on: html ].
			html text: '->' ].
	self selectedSuperclass == nil
		ifTrue: [ html strong: aClass name ]
		ifFalse: [ 
			self
				renderLink: [ :s | 
					self selectedSuperclass: nil.
					aBlock value.
					main updateCenterSideHistory: s ]
				with: [ html strong: aClass name ]
				on: html ]! !

!TOClassBasedBrowser methodsFor: 'accessing' stamp: 'dkh 5/24/2011 01:11'!
selectedSuperclass
	^ selectedSuperclass! !

!TOClassBasedBrowser methodsFor: 'accessing' stamp: 'dkh 5/24/2011 01:11'!
selectedSuperclass: anObject
	^ selectedSuperclass := anObject! !

TOView subclass: #TOCodeBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-Views'!

TOCodeBrowser subclass: #TOClassBrowser
	instanceVariableNames: 'classDefinition classTemplate'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-Views'!

!TOClassBrowser methodsFor: 'accessing' stamp: 'dkh 5/23/2011 19:04'!
classDefinition

	classDefinition ifNil: [ classDefinition := self classDefinitionTemplate: self classTemplate ].
	^ classDefinition! !

!TOClassBrowser methodsFor: 'accessing' stamp: 'dkh 5/23/2011 18:31'!
classDefinition: anObject
	classDefinition := anObject! !

!TOClassBrowser methodsFor: 'accessing' stamp: 'dkh 5/24/2011 00:08'!
classTemplate
	"#explorer, #definition, #subclass or #new"
	
	classTemplate ifNil: [ classTemplate := #explorer ].
	^classTemplate ! !

!TOClassBrowser methodsFor: 'rendering' stamp: 'dkh 5/23/2011 23:53'!
renderClassDefinitionOn: html main: main

	self 
		renderControl: [ :id :scrpt |
			html textArea
				id: id;
				columns: 80;
				rows: self classDefinition lineCount + 1;
				value: self classDefinition ;
				onKeyUpMap: {
					17 "ctl" -> (html jQuery ajax
						script: [:s | ctlKeyPressed := false ])};
				onKeyDownMap: {
					17 "ctl" -> (html jQuery ajax
						script: [:s | ctlKeyPressed := true ]).
					83 "s"-> (html jQuery ajax
					callback: [ :value | classDefinition := value .  ] value: (html jQuery id: id) value;
						script: [:s | 
							ctlKeyPressed 
								ifTrue: [
									"ctl-s"
									ctlKeyPressed := false]]).};
				callback: [ :value | classDefinition := value ];
				onChange: (scrpt html: [ :h | h render: self classDefinition ]) ] 
		on: html.
! !

!TOClassBrowser methodsFor: 'rendering' stamp: 'dkh 5/23/2011 20:47'!
renderCommandsOn: html main: main

	self 
		renderCommandLink: #copyClass:id: label: 'Copy...' message: 'Copy... not implement' on: html main: main;
		renderCommandLink: #removeClass:id: label: 'Remove class...' message: 'Remove class... not implemented' on: html main: main;
		renderCommandLink: #renameClass:id: label: 'Rename...' message: 'Rename... not implemented' on: html main: main;
		yourself! !

!TOClassBrowser methodsFor: 'rendering' stamp: 'dkh 5/23/2011 23:55'!
renderContentOn: html main: main

	self renderClassHeading: self actualClass on: html main: main.
	html break; break.
	self renderCommandsOn: html main: main.
	html break.
	self renderDefinitionTypeChoiceOn: html main: main.
	html break.
	self classTemplate == #explorer
		ifTrue: [ self renderClassExplorerOn: html main: main ]
		ifFalse: [ self renderClassDefinitionOn: html main: main ]
! !

!TOClassBrowser methodsFor: 'rendering' stamp: 'dkh 5/23/2011 20:58'!
renderDefinitionTypeChoiceLink: definitionType label: label on: html main: main
	self
		renderLink: [ :s | 
			classTemplate := definitionType.
			classDefinition := nil.
			main updateCenterSideHistory: s ]
		with: [ html text: label ]
		on: html.
	html space
! !

!TOClassBrowser methodsFor: 'rendering' stamp: 'dkh 5/24/2011 00:23'!
renderDefinitionTypeChoiceOn: html main: main
	| type |
	type := self classTemplate.
	html break.
	type ~~ #explorer
		ifTrue: [ self renderDefinitionTypeChoiceLink: #explorer label: 'explorer' on: html main: main ]
		ifFalse: [ html text: 'explorer'; space ].
	type ~~ #definition
		ifTrue: [ self renderDefinitionTypeChoiceLink: #definition label: 'Class definition' on: html main: main ]
		ifFalse: [ html text: 'Class definition'; space ].
	type ~~ #new
		ifTrue: [ self renderDefinitionTypeChoiceLink: #new label: 'New class template' on: html main: main ]
		ifFalse: [ html text: 'New class template'; space ].
	type ~~ #subclass
		ifTrue: [ self renderDefinitionTypeChoiceLink: #subclass label: 'Subclass template' on: html main: main ]
		ifFalse: [ html text: 'Subclass template'; space ].
! !

!TOClassBrowser methodsFor: 'rendering' stamp: 'dkh 5/24/2011 01:37'!
renderSuperclassHeading: aClass on: html main: main
	self sharedClassState
		renderSuperclassHeading: aClass
		whenClicked: [ classDefinition := nil ]
		on: html
		main: main! !

!TOCodeBrowser methodsFor: 'accessing' stamp: 'dkh 5/24/2011 01:43'!
actualClass

	self object isBehavior
		ifTrue: [ ^self object ].
	^super actualClass! !

!TOCodeBrowser methodsFor: 'rendering' stamp: 'dkh 5/24/2011 01:44'!
renderCommandLink: commandSelector label: label message: message on: html main: main
	| id |
	(html div)
		id: (id := html nextId);
		script:
				((html jQuery new dialog)
					html: message;
						title: 'Information';
						resizable: false;
						modal: true).
	self
		renderLink: [ :s | 
			| success result frame |
			success := true.
			[ 
			result := self
				perform: commandSelector
				withArguments: {s. id} ] on: TOAbortCommand do: [ :ex | success := false ].
			self properties
				at: 'result'
				put:
					{result.
					success}.
			success
				ifTrue: [ 
					frame := main currentSpace push: result.
					frame selectedCenterTab: #class.
					main updateCenterSideHistory: s ] ]
		with: [ html text: label ]
		on: html.
	html space! !

!TOCodeBrowser methodsFor: 'accessing' stamp: 'dkh 5/24/2011 01:43'!
theClass

	^self selectedSuperclass ifNil: [ self actualClass ]! !

TOCodeBrowser subclass: #TOMethodBrowser
	instanceVariableNames: 'methodTemplate methodSource methodReference'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-Views'!

!TOMethodBrowser methodsFor: 'accessing' stamp: 'dkh 5/24/2011 01:51'!
methodReference
	^ methodReference! !

!TOMethodBrowser methodsFor: 'accessing' stamp: 'dkh 5/24/2011 01:51'!
methodReference: anObject
	methodReference := anObject.
	methodSource := nil! !

!TOMethodBrowser methodsFor: 'accessing' stamp: 'dkh 5/24/2011 01:50'!
methodSource
	methodSource
		ifNil: [ 
			self methodReference
				ifNil: [ 
					methodSource := 'messageSelectorAndArgumentNames
	"comment stating purpose of message"

	| temporary variable names |
	statements' ]
				ifNotNil: [ methodSource := self methodReference sourceCode ] ].
	^ methodSource! !

!TOMethodBrowser methodsFor: 'accessing' stamp: 'dkh 5/24/2011 01:47'!
methodTemplate
	"#explorer, #editor"
	
	methodTemplate ifNil: [ methodTemplate := #explorer ].
	^methodTemplate ! !

!TOMethodBrowser methodsFor: 'rendering' stamp: 'dkh 5/24/2011 01:41'!
renderCommandsOn: html main: main

	self 
		renderCommandLink: #copyClass:id: label: 'Copy...' message: 'Copy... not implement' on: html main: main;
		renderCommandLink: #removeClass:id: label: 'Remove class...' message: 'Remove class... not implemented' on: html main: main;
		renderCommandLink: #renameClass:id: label: 'Rename...' message: 'Rename... not implemented' on: html main: main;
		yourself! !

!TOMethodBrowser methodsFor: 'rendering' stamp: 'dkh 5/24/2011 01:53'!
renderContentOn: html main: main

	self renderClassHeading: self actualClass on: html main: main.
	html break; break.
	self renderCommandsOn: html main: main.
	html break.
	self renderDefinitionTypeChoiceOn: html main: main.
	html break.
	self methodTemplate == #explorer
		ifTrue: [ self renderMethodExplorerOn: html main: main ]
		ifFalse: [ self renderMethodSourceOn: html main: main ]
! !

!TOMethodBrowser methodsFor: 'rendering' stamp: 'dkh 5/24/2011 01:50'!
renderDefinitionTypeChoiceLink: definitionType label: label on: html main: main

	self
		renderLink: [ :s | 
			methodTemplate := definitionType.
			methodSource := nil.
			main updateCenterSideHistory: s ]
		with: [ html text: label ]
		on: html.
	html space
! !

!TOMethodBrowser methodsFor: 'rendering' stamp: 'dkh 5/24/2011 01:46'!
renderDefinitionTypeChoiceOn: html main: main
	| type |
	type := self methodTemplate.
	html break.
	type ~~ #explorer
		ifTrue: [ self renderDefinitionTypeChoiceLink: #explorer label: 'explorer' on: html main: main ]
		ifFalse: [ html text: 'explorer'; space ].
	type ~~ #definition
		ifTrue: [ self renderDefinitionTypeChoiceLink: #definition label: 'editor' on: html main: main ]
		ifFalse: [ html text: 'editor'; space ].
! !

!TOMethodBrowser methodsFor: 'rendering' stamp: 'dkh 5/24/2011 01:57'!
renderMethodExplorerOn: html main: main
	self renderControl: [ :id :scrpt |  ] on: html! !

!TOMethodBrowser methodsFor: 'rendering' stamp: 'dkh 5/24/2011 01:54'!
renderMethodSourceOn: html main: main
	
	| cat |
	self 
		renderControl: [ :id :scrpt |
			html textArea
				id: id;
				columns: self textAreaColumns;
				rows: self textAreaRows;
				value: self methodSource;
				onKeyUpMap: {
					17 "ctl" -> (html jQuery ajax
						script: [:s | ctlKeyPressed := false ])};
				onKeyDownMap: {
					17 "ctl" -> (html jQuery ajax
						script: [:s | ctlKeyPressed := true ]).
					83 "s"-> (html jQuery ajax
					callback: [ :value | methodSource := value .  ] value: (html jQuery id: id) value;
						script: [:s | 
							ctlKeyPressed 
								ifTrue: [
									"ctl-s"
									ctlKeyPressed := false]]).};
				callback: [ :value | methodSource := value ];
				onChange: (scrpt html: [ :h | h render: self methodSource ]) ] 
		on: html.
! !

!TOMethodBrowser methodsFor: 'accessing' stamp: 'dkh 5/24/2011 01:55'!
textAreaColumns

	| lineWidth src tab |
	lineWidth := 0.
	tab := Character tab.
	(src := self methodSource) lineIndicesDo: [:start :endWithoutDelimiters :end | | tabs |
		tabs := 0.
		start to: endWithoutDelimiters do: [:index | 
			(src at: index) = tab ifTrue: [ tabs := tabs + 5 ]].
		lineWidth := lineWidth max: (end - start + 1 + tabs)].
	^lineWidth! !

!TOMethodBrowser methodsFor: 'accessing' stamp: 'dkh 5/24/2011 01:55'!
textAreaRows

	^self methodSource lineCount! !

TOView subclass: #TOInspector
	instanceVariableNames: 'basicInspect toggleVisible basicMembers'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-Views'!

!TOInspector methodsFor: 'private' stamp: 'dkh 5/23/2011 23:28'!
basicFieldsFor: anObject

	(Pragma allNamed: #tODEBasicInspectorFields from: anObject class to: nil) do: [:pragma |
		^anObject perform: pragma method selector ].
	^#()! !

!TOInspector methodsFor: 'private' stamp: 'dkh 5/23/2011 23:28'!
fieldsFor: anObject

	(Pragma allNamed: #tODEInspectorFields from: anObject class to: nil) do: [:pragma |
		^anObject perform: pragma method selector ].
	^#()! !

!TOInspector methodsFor: 'rendering' stamp: 'dkh 5/23/2011 09:25'!
getMembers
	| members |
	basicMembers := toggleVisible := true.
	basicInspect
		ifTrue: [ members := self basicFieldsFor: self object ]
		ifFalse: [ 
			members := self fieldsFor: self object.
			members isEmpty
				ifTrue: [ 
					members := self basicFieldsFor: self object.
					toggleVisible := false ]
				ifFalse: [ basicMembers := false ] ].
	^ members! !

!TOInspector methodsFor: 'initialize-release' stamp: 'dkh 5/23/2011 09:25'!
initialize

	super initialize.
	basicInspect := toggleVisible := basicMembers := false.! !

!TOInspector methodsFor: 'rendering' stamp: 'dkh 5/23/2011 23:40'!
renderBasicToggleOn: html main: main
	toggleVisible
		ifTrue: [
			self
				renderLink: [ :s | 
					basicInspect := basicInspect not.
					main updateCenterOn: s ]
				with: (basicInspect ifTrue: [ 'standard inspector' ] ifFalse: [ 'basic inspector'])
				on: html.
			html break ].
! !

!TOInspector methodsFor: 'rendering' stamp: 'dkh 5/23/2011 21:06'!
renderContentOn: html main: main
	| members classText actualClass |
	members := self getMembers.
	actualClass := self actualClass.
	classText := self object isBehavior
		ifTrue: [ 'the Class ', actualClass name]
		ifFalse: ['an instance of ', actualClass name ].
	(html heading)
		level: 3;
		with:
				(basicMembers
						ifTrue: ['Basic Inspector on ', classText ]
						ifFalse: ['Inspector on ', classText ]).
	self renderMembers: members on: html main: main.
	html break.
	self renderBasicToggleOn: html main: main! !

!TOInspector methodsFor: 'rendering' stamp: 'dkh 5/22/2011 17:45'!
renderMembers: members on: html main: main
	members
		do: [ :assoc | 
			self
				renderLink: [ :s | 
					| frame |
					frame := main currentSpace push: assoc value.
					frame selectedCenterTab: #inspect.
					main updateCenterSideHistory: s ]
				with: assoc key
				on: html.
			html text: ' -> ' , (assoc value printStringLimitedTo: 50).
			html break ]! !
